C	ABI_UTILS.FOR
C	09-AUG-2000, David Mathog, Biology Division, Caltech
C
C	routines, used in ABIBREAKOUT to return data from ABI chromatogram
C
	subroutine getabifortran(
	1 filename,
	1 npoints,
	1 norigbases,
	1 maxTraceVal,
	1 tC, tA, tG, tT,
	1 bases,
	1 basePos,
	1 maxpoints, maxbases,
	1 info,
	1 maxinfo,maxinfotypes,
	1 phd, shownovel)
	
	implicit none
	
c
c	the parameters to return
c
	integer*4 maxpoints,maxBases,maxinfo,maxinfotypes
	integer*4 Npoints,NorigBases
	integer*2 maxTraceVal
	integer*2 tC(maxpoints),tA(maxpoints)
	integer*2 tG(maxpoints),tT(maxpoints)
	character*1 bases(maxbases)
	character*1 info(maxinfo,maxinfotypes)
	integer*2   basepos(maxbases)
	character*1 filename(255)
	logical phd, shownovel
c
c	
	integer*2 temp
	integer*4 MAXFILE
	parameter (MAXFILE=2**20)
	character*1 array(MAXFILE)   !A 1Mb array to hold the file
	character*120 infile
	integer flagsum
	parameter (flagsum=61)
	character*7 flagtypes(flagsum)
	integer*4 irec,brec,istat,incount,inlen,ipoint
	integer*4 lastbyte
	integer*4 offset
	integer*4 action
c
	character*4 flag
	integer*4 datatype,datasize
	integer*4 instance,nrecords,nbytes,value
	integer*4 spare
	integer*4 opmode,retpointer
	character*32000 retstring
c
	logical flagcompare
c
	data flagtypes/	             ! if you change this be sure to change "flagsum"!!!
	1                 ' tdir 0'  !jump to offset, no action
	1                ,' AEPt 1'  !immediate single value
	1                ,' APFN 3'  !indirect multiple value     3700
	1                ,' ASPF 1'  !immediate single value
	1                ,' ASPt 1'  !immediate single value
	1                ,' AUTO 2'  !immediate multiple value
	1                ,' B1Pt 1'  !immediate single value
	1                ,' CAGT 2'  !immediate multiple value
	1                ,' CCDF 1'  !immediate single value   3700
	1                ,' CMBF 3'  !indirect multiple value
	1                ,' CMNT 3'  !indirect multiple value
	1                ,' CpEP 1'  !immediate single value     3700
	1                ,' CTTL 3'  !indirect multiple value
	1                ,' DATA 3'  !indirect multiple value
	1                ,' DyeN 3'  !indirect multiple value    3700
	1                ,' Dye# 1'  !immediate single value     3700
	1                ,' DySN 1'  !immediate single value     3700
	1                ,' EVNT 3'  !indirect multiple value
	1                ,' FWO_ 2'  !immediate multiple value
	1                ,' GELN 3'  !indirect multiple value
	1                ,' GLEN 3'  !indirect multiple value
	1                ,' GELP 3'  !indirect multiple value
	1                ,' GTyp 3'  !indirect multiple value    3700
	1                ,' LANE 2'  !immediate multiple value
	1                ,' LNTD 1'  !immediate single value     3700
	1                ,' MCHN 3'  !indirect multiple value
	1                ,' MODF 3'  !indirect multiple value    3700
	1                ,' MODL 2'  !immediate multiple value
	1                ,' MTRX 3'  !indirect multiple value
	1                ,' MTXF 3'  !indirect multiple value
	1                ,' NAVG 1'  !immediate single value
	1                ,' NCHn 1'  !immediate single value
	1                ,' NChn 1'  !immediate single value
	1                ,' NLNE 1'  !immediate single value
	1                ,' OFFS 1'  !immediate single value     3700
	1                ,' PBAS 3'  !indirect multiple value
	1                ,' PCON 3'  !indirect mulitple value     3700
	1                ,' PDMF 3'  !indirect multiple value
	1                ,' PLOC 3'  !indirect multiple value
	1                ,' PPOS 1'  !immediate single value
	1                ,' RATE 9'  !??                           3700
	1                ,' RevC 1'  !immediate single value     3700
	1                ,' RSPN 1'  !immediate single value
	1                ,' RUND 1'  !immediate single value
	1                ,' RUNT 1'  !immediate single value
	1                ,' S/N% 3'  !indirect multiple value
	1                ,' ScSt 1'  !immediate single value    3700
	1                ,' SCAN 1'  !immediate single value    3700
	1                ,' Scan 1'  !immediate single value    3700
	1                ,' SMED 3'  !indirect multiple value    3700
	1                ,' SMLt 3'  !indirect multiple value    3700
	1                ,' SMPL 3'  !indirect multiple value
	1                ,' SPAC 6'  !immediate single value or indirect multiple value
	1                ,' SVER 5'  !immediate or indirect multiple value
	1                ,' THUM 4'  !indirect single value
	1                ,' TRKC 2'  !immediate multiple value
	1                ,' TRKI 1'  !immediate single value
	1                ,' TRKP 2'  !immediate multiple value
	1                ,' TRKP 2'  !immediate multiple value
	1                ,' TUBE 1'  !immediate single value    3700
	1                ,' drty 0'  !jump to offset, no action
	1/


	external flagcompare
c
c
c
	maxtraceval=0
c
	inlen=1
	do while(filename(inlen) .ne. char(0))
	  infile(inlen:inlen)=filename(inlen)
	  inlen = inlen + 1
	end do
	inlen = inlen - 1
c
	open(unit=10
	1 ,file=infile(1:inlen)
	1 ,form='UNFORMATTED',status='OLD'
	1 ,ORGANIZATION='SEQUENTIAL'
	1 ,RECORDTYPE='FIXED'
	1 ,READONLY,iostat=istat)
	if(istat.ne.0)stop 'Fatal error, something wrong with input file'

c
	inquire(10,RECL=irec)			!longwords, because unformmated
	if(irec.lt.0)then			!error...
	   stop 'ABIBreakout fatal error, illegal record size'
	else
	   brec=irec*4				!bytes/record
	end if
c
c	zero the info field
c
	call zeroinfo(info,maxinfo,maxinfotypes)
	
	ipoint=1
	incount=0
	istat = 0
	do while(istat .ge. 0 .and. ipoint .le. MAXFILE - brec + 1)
	   call getrec(array(ipoint),irec*4,istat)
	   if(istat.eq.0)then
	      ipoint=ipoint+brec
	      incount = incount + 1
	   end if
	end do
	lastbyte = incount*brec
	close(10)
C
C	Determine if it is a MacBinary or not by the position of the ABIF
C	flag
C
	if(flagcompare(array(1),'ABIF'))then
	  offset = 1  !correction from file pointer to Fortran array pointers
	  ipoint = 7  !position of first FLAG structure
	else if(flagcompare(array(129),'ABIF'))then
	  offset = 129
	  ipoint = 135
	else
	  stop 'Fatal error - input file is not an ABI trace file'
	end if
	call getflag(array(ipoint)
	1  ,flag,instance,datatype,datasize,nrecords
	1  ,nbytes,value,spare,1)
	call getaction(flagtypes,flagsum,flag,instance,action)
	if(action .ne. 0)stop 'Fatal error, input file invalid'
	ipoint = offset + value
	action = 1
c
c
	do while(action .ne. 0)
	  call getflag(array(ipoint)
	1  ,flag,instance,datatype,datasize,nrecords
	1  ,nbytes,value,spare,0)
	  call getaction(flagtypes,flagsum,flag,instance,action)
C
C	Matrix overlays an odd,  signed integer 2 onto the unsigned
C	integer 2 datatype (4).  Make up a datatype for use in this
C	program that does not exist in ABI files
C
	  opmode=1  ! NEVER Use 0 here as there is no output file!!! 
	  if(action .ne. 0)then
	    if(flag .eq. 'MTRX')datatype = 1004
	    call writefield(6, array,action, offset
	1      ,flag,instance,datatype,datasize
	1      ,nrecords,nbytes,value,spare
	1      ,opmode,retpointer,retstring,shownovel)
C
C	this section stuffs the data into the appropriate fields.
C	note how copystring 
C

	    if(flagcompare(flag,'MCHN'))then
	      call copystring(info,maxinfo,maxinfotypes,1,
	1     'Machine: ',-9,1)
	      call appendstring(info,maxinfo,maxinfotypes,1,
	1     retstring,retpointer,13)
	    else if(flagcompare(flag,'SMPL'))then
	      call copystring(info,maxinfo,maxinfotypes,3,
	1     'Sample: ',-8,1)
	      call appendstring(info,maxinfo,maxinfotypes,3,
	1     retstring,retpointer,13)
	    else if(flagcompare(flag,'PDMF'))then
	      call copystring(info,maxinfo,maxinfotypes,5,
	1     'DyeSet: ',-8,1)
	      call appendstring(info,maxinfo,maxinfotypes,5,
	1     retstring,retpointer,13)
	    else if(flagcompare(flag,'TUBE'))then
	      call copystring(info,maxinfo,maxinfotypes,6,
	1     'Tube: ',-6,1)
	      call appendstring(info,maxinfo,maxinfotypes,6,
	1     retstring,retpointer,13)
	    else if(flagcompare(flag,'LANE'))then
	      call copystring(info,maxinfo,maxinfotypes,6,
	1     'Lane: ',-6,1)
	      call appendstring(info,maxinfo,maxinfotypes,6,
	1     retstring,retpointer,13)
	    else if(flagcompare(flag,'SPAC'))then
	      call copystring(info,maxinfo,maxinfotypes,7,
	1     'Spacing: ',-9,1)
	      call appendstring(info,maxinfo,maxinfotypes,7,
	1     retstring,retpointer,13)
	    else if(flagcompare(flag,'SCAN'))then
	      call copystring(info,maxinfo,maxinfotypes,8,
	1     'Points: ',-8,1)
	      call appendstring(info,maxinfo,maxinfotypes,8,
	1     retstring,retpointer,13)
	    else if(flagcompare(flag,'RUND'))then
	      if(instance .eq. 1)then
	        call copystring(info,maxinfo,maxinfotypes,8+instance,
	1       'Start: ',-7,1)
	      else if (instance .eq. 2)then
	        call copystring(info,maxinfo,maxinfotypes,8+instance,
	1       'Stop:  ',-7,1)
	      end if
	      if(instance .le. 2)then
	        call appendstring(info,maxinfo,maxinfotypes,8+instance,
	1          retstring,-12,13)
	      end if
	    else if(flagcompare(flag,'RUNT'))then
	      if(instance .le. 2)then
	        call appendstring(info,maxinfo,maxinfotypes,8+instance,
	1          retstring,retpointer,13)
	      end if
	    else if(flagcompare(flag,'DATA'))then
	      if(instance .eq. 9)then
	        npoints=nrecords
	        call loadint2(tG,array(retpointer),
	1       nrecords,maxtraceval)
	      else if(instance .eq. 10)then
	        call loadint2(tA,array(retpointer),
	1       nrecords,maxtraceval)
	      else if(instance .eq. 11)then
	        call loadint2(tT,array(retpointer),
	1       nrecords,maxtraceval)
	      else if(instance .eq. 12)then
	        call loadint2(tC,array(retpointer),
	1       nrecords,maxtraceval)
	      end if
	    else if(flagcompare(flag,'PBAS') 
	1     .and. instance .eq. 1)then
	        norigbases= nrecords
		if(.not. phd)call copystring(bases,maxbases,1,1,
	1          array(retpointer),-nrecords,1)
	    else if(flagcompare(flag,'PLOC') 
	1     .and. instance .eq. 1)then
	        if(.not. phd)call loadint2(basepos,array(retpointer),
	1       nrecords,temp)
	    end if
!	    write(6,*)
!	1      ' retpointer ',retpointer,
!	1      ' retstring(1:11) ',retstring(1:11)
	  end if
	  ipoint = ipoint + 28
	end do
	
	return
	end

	subroutine getrec(scratch,size,stat)
	implicit none
	integer*4 size,stat
	character*1 scratch(size)
	read(10,iostat=stat)scratch
	return
	end


	logical function flagcompare(array,text)
	implicit none
	character*1    array(4)
	character*4    text
c
	integer i
c
	flagcompare = .true.
	do i = 1,4
	  if(array(i) .ne. text(i:i))then
	     flagcompare = .false.
	     return
	  end if
	end do
	return
	end

	subroutine getflag(array
	1  ,flag,instance,datatype,datasize,nrecords
	1  ,nbytes
	1  ,value
	1  ,spare,swap)
	implicit none
c
	character*1 array(28)
	character*4 flag
	integer*4 datatype,datasize
	integer*4 instance,nrecords,nbytes
	integer*4 value
	integer*4 spare,swap
c
	integer*4 i
c
	character*1 ca(4)
	byte        ba(4)
	integer*2   wa(2)
	integer*4   la
	equivalence (ca,ba,wa,la)
c
c	extract flag
c
	do i = 1,4
	  flag(i:i) = array(i)
	end do
c
c	extract instance
c
	do i = 1,4
	  ca(i)=array(9-i)
	end do
	instance = la
c
c	extract datatype and datasize
c
	do i = 1,4
	  ca(i)=array(13-i)
	end do
	datatype=wa(2)
	datasize=wa(1)
c
c	extract Nrecords
c
	do i = 1,4
	  ca(i)=array(17-i)
	end do
	nrecords = la
c
c	extract Nbytes
c
	do i = 1,4
	  ca(i)=array(21-i)
	end do
	nbytes = la
c
c	extract value - swap or not depend on SWAP
c
	if(swap .eq. 1)then
	  do i = 1,4
	    ca(i)=array(25 - i)
	  end do
	else
	  do i = 1,4
	    ca(i)=array(20+i)
	  end do
	end if
	value = la
c
c	extract spare
c
	do i = 1,4
	  ca(i)=array(29-i)
	end do
	spare = la
c
	return
	end

	subroutine getaction(flagtypes,num,flag,instance,action)
	implicit none
	integer*4     action,num,instance
	character*4   flag
	character*7 flagtypes(num)
c
	integer*4 i,k
c
	do i = 1,num
	  k = index(flagtypes(i),flag)
	  if(k .ne. 0)then
	     action = ichar(flagtypes(i)(7:7))  - ichar('0')
c
c	The SVER field is screwy, the first instance is IMMEDIATE MULTIPLE
c	and the second instance is INDIRECT MULTIPLE.  Blame ABI
c	for some silly programming.
c
	     if(action .eq. 5)then
	        if(instance .eq. 1)then
	           action = 2
	        else
	           action = 3
	        end if
	     end if
c
c	The SPAC field is screwy, the first instance is IMMEDIATE SINGLE
c	and the second instance is INDIRECT MULTIPLE with a completely 
c	different data type, and the third is back to IMMEDIATE SINGLE 
c	again.  Blame ABI for some silly programming.
c
	     if(action .eq. 6)then
	        if(instance .eq. 2)then
	           action = 3
	        else
	           action = 1
	        end if
	     end if
c
	     return
	  end if	  
	end do
	action = -1
c
	return
	end

C
C	like C strlen, except that the string will always
C	have a series of trailing spaces, so define the "end"
C	of the string as the last nonspace character
C	back is where it starts looking.  In this program most strings
C	are short so back can be 256 or so.  But some strings can be
C	very long, like PBAS.  That means the buffer has to be large
C	and it will save some time to specify BACK <<< real end
C
	integer function slen(string,back)
	implicit none
	integer back
	character*(*) string
C
	do slen=back,1,-1
	  if(string(slen:slen) .ne. ' ')return
	end do
        return
        end

C	opmode
C	0  write to output file
C	1  return value.  This is really only useful for fields
C	   which return a string or a pointer to an array. If
C	   retpointer is < 0 then a string has been returned and this
C	   is the number of characters it contains.

	subroutine writefield(unit, array,action, offset
	1    ,flag,instance,datatype,datasize,nrecords
	1    ,nbytes,value,spare
	1    ,opmode,retpointer,retstring,shownovel)
	implicit none
c
	character*1 array(1)
	integer*4 unit,action,offset
	integer*4 instance,datatype,datasize
	integer*4 nrecords, nbytes
	integer*4 value,spare
	integer*4 opmode,retpointer
	character*(*) retstring
	character*4 flag
	logical   shownovel
c
	real*4    rtemp
	integer*4 i,k,ipoint
	logical novel
        integer*4 slen,back
c
	character*1 ca(4)
	byte        ba(4),btemp
	integer*2   wa(2)
	integer*4   la
	real*4      ra     
	equivalence (ca,ba,wa,la,ra)
	
	character*3 months(12)
	data months/
	1 'Jan','Feb','Mar','Apr','May','Jun',
	1 'Jul','Aug','Sep','Oct','Nov','Dec' /
c
c	perform the appropriate action.  If action <=0 nothing happens
c
	novel = .false.
	retpointer=-1  ! most of these will return a string
	back=128       ! this speeds things up - if we can limit the string
	               ! length
	if(action .eq. 1)then  !immediate single value
	  la = value
	  if(datatype .eq. 2)then
	    write(retstring,1002)flag,instance,(ca(i),i=1,nbytes)
	  else if(datatype .eq. 4)then
	    btemp=ba(2)
	    ba(2)=ba(1)
	    ba(1)=btemp
	    write(retstring,1004)flag,instance,wa(1)
	  else if(datatype .eq. 5)then
	    btemp=ba(4)
	    ba(4)=ba(3)
	    ba(3)=btemp
	    write(retstring,1004)flag,instance,wa(2)
	  else if(datatype .eq. 7)then
	    do i = 1,2
	      btemp = ba(5-i)
	      ba(5-i) = ba(i)
	      ba(i) = btemp
	    end do
	    write(retstring,1007)flag,instance,ra
	  else if(datatype .eq. 10)then
	    btemp=ba(2)
	    ba(2)=ba(1)
	    ba(1)=btemp
	    write(retstring,1010)flag,instance,ba(4),months(ba(3)),wa(1)
	  else if(datatype .eq. 11)then
	    write(retstring,1011)flag,instance,ba(1),ba(2),ba(3)
	  else if(datatype .eq. 18)then
	    write(retstring,1018)flag,instance,(ca(k),k=2,ichar(ca(1))+1)
	  else
	    novel = .true.
	  end if
	else if(action .eq. 2)then !immediate multiple value
	  la = value
	  if(datatype .eq. 2)then
	    write(retstring,1002)flag,instance,value
	  else if(datatype .eq. 4)then
	    do i = 1,2
	      btemp = ba(5-i)
	      ba(5-i) = ba(i)
	      ba(i) = btemp
	    end do
	    write(retstring,2004)flag,instance,wa(1),wa(2)
	  else if(datatype .eq. 13)then
	    i = nbytes
	    write(retstring,2013)flag,instance,(ba(i),k=1,i)
	  else if(datatype .eq. 18)then
	    k = jiand('ff'x,value)
	    la = value
	    write(retstring,3018)flag,instance,(  ca(i),i=2,1+k)
	  else
	    novel = .true.
	  end if
	else if(action .eq. 3)then !indirect multiple value
	  la = value  ! always an offset into the file
	  do i = 1,2
	    btemp = ba(5-i)
	    ba(5-i) = ba(i)
	    ba(i) = btemp
	  end do
	  ipoint = la + offset !now we know where in the array
c
	  if(datatype .eq. 2)then
	    if(ipoint .ne. offset)then
	      if(opmode .eq. 0)then
	         write(unit,3002)flag,instance,
	1          (array(i),i=ipoint,ipoint+nbytes-1)
	      else
	         write(retstring,30025)flag,instance
		 retpointer=ipoint
	      end if
	      return
	    else
	      write(retstring,1002)flag,instance,'NONE'
	    end if
	  else if(datatype .eq. 4)then
	    wa(2)=0
	    if(ipoint .ne. offset)then
	      write(retstring,30025)flag,instance
	      if(opmode .eq. 0)write(unit,9999)retstring(1:slen(retstring,128))
	      retpointer=ipoint
	      do i = 1, nrecords
	        ca(2)=array(ipoint)
	        ipoint = ipoint + 1
	        ca(1)=array(ipoint)
	        ipoint = ipoint + 1
	        if(opmode .eq. 0)then
		   write(unit,30045)i,la
		else  ! store value back into array with bytes in order
		   array(ipoint-1)=ca(2)
		   array(ipoint-2)=ca(1)
		end if
	      end do
	      return
	    else
	      write(retstring,1002)flag,instance,'NONE'
	    endif
	  else if(datatype .eq. 1004)then
	    wa(2)=0
	    if(ipoint .ne. offset)then
	      write(retstring,30025)flag,instance
	      if(opmode .eq. 0)write(unit,9999)retstring(1:slen(retstring,128))
	      retpointer=ipoint
	      do i = 1, nrecords
	        ca(2)=array(ipoint)
	        ipoint = ipoint + 1
	        ca(1)=array(ipoint)
	        ipoint = ipoint + 1
	        rtemp = float(wa(1))/1000.
	        if(opmode .eq. 0)then
		   write(unit,30046)i,rtemp
		else  ! store original value back into array with bytes in order
		   array(ipoint-1)=ca(2)
		   array(ipoint-2)=ca(1)
		end if
	      end do
	      return
	    else
	      write(retstring,1002)flag,instance,'NONE'
	    endif
	  else if(datatype .eq. 18)then
	    if(ipoint .ne. offset)then
!	write(6,*)'3-18: ipoint ',ipoint,' array of ipoint ',ichar(array(ipoint)),' flag ',flag
	      write(retstring,3018)flag,instance,(array(i),i=ipoint+1,ipoint+ichar(array(ipoint)))
	    else
	      write(retstring,1002)flag,instance,'NONE'
	    end if
	  else
	    novel = .true.
	  end if
	else if(action .eq. 4)then !indirect single value
	  la = value  ! always an offset into the file
	  do i = 1,2
	    btemp = ba(5-i)
	    ba(5-i) = ba(i)
	    ba(i) = btemp
	  end do
	  ipoint = la + offset !now we know where in the array
c
	  if(datatype .eq. 12)then  !THUM structures
	    write(retstring,4012)flag,instance,(ichar(array(i)),i=ipoint,ipoint+9)
	  else
	    novel = .true.
	  end if
	else !new action, unknown
	   novel = .true.
	   if(flag(1:1) .eq. char(0))then
	      action=0  ! forces termination of processing
	      return
	   end if
	end if
c
	if(novel)then
	   if(shownovel)write(6,9000)flag,instance,datatype,datasize
	1        ,nrecords,nbytes,value,spare
	else
	    if(opmode .eq. 0)then
	      write(unit,9999)retstring(1:slen(retstring,128))
	    else
	      retpointer=-slen(retstring,128)
	    end if
	end if

9000	format(' Novel FLAG structure encountered',/
	1      ' FLAG:        ',a4,/
	1      '  instance   ',i6,/
	1      '  datatype   ',i6,/
	1      '  datasize   ',i6,/
	1      '  nrecords   ',i6,/
	1      '  nbytes     ',i6,/
	1      '  value(hex) ',z8,/
	1      '  spare(hex) ',z8)

1002	format('>',a4,i6,' ',a4)
1004	format('>',a4,i6,' ',i6)
1007	format('>',a4,i6,' ',f9.3)
C	1010	format('>',a4,i6,' ',i6,'(y)',i3,'(m)',i3,'(d)')
C	1011	format('>',a4,i6,' ',i6,'(h)',i3,'(m)',i3,'(s)')
1010	format('>',a4,i6,' ',i2,'-',a,'-',i4)
1011	format('>',a4,i6,' ',i2,':',i2,':',i2)
1018	format('>',a4,i6,' ',4a)
2004	format('>',a4,i6,2(' ',i6))
2013	format('>',a4,i6,4(' ',z6))
3002	format('>',a4,i6,' ',/,5000(50a,/))
30025	format('>',a4,i6)
3004	format('>',a4,i6, '(Pos,Value)')
30045	format('   ',i6,',',i6)
30046	format('   ',i6,',',f7.3)
3018	format('>',a4,i6,' ',256a)
4012	format('>',a4,i6,' ',z2,9(',',z2))
9999	format(a)

	return
	end
	
	subroutine copystring(info,maxinfo,maxinfotypes,slot
	1  ,retstring,retpointer,start)
	implicit none
	integer*4 maxinfo,maxinfotypes,slot,retpointer,start
	character*(*) retstring
	character*1 info(maxinfo,maxinfotypes)
	integer*4 i,j
C	
	if(retpointer .ge. 0)stop 'ABIprintout fatal error - bad flag field'
	j=start
	do i = 1, -(retpointer)
	  info(i,slot)=retstring(j:j)
	  j=j+1
	end do
	info(1 - retpointer,slot)=char(0)
C
	return
	end
	
	subroutine appendstring(info,maxinfo,maxinfotypes,slot
	1  ,retstring,retpointer,start)
	implicit none
	integer*4 maxinfo,maxinfotypes,slot,retpointer,start
	character*(*) retstring
	character*1 info(maxinfo,maxinfotypes)
	integer*4 i,j,k
C	
	if(retpointer .ge. 0)stop 'ABIprintout fatal error - bad flag field'
	k=1
	do while(info(k,slot) .ne. char(0))
	  k=k+1
	end do
	
	j=start
	do i = k, k - retpointer - 1
	  info(i,slot)=retstring(j:j)
	  j=j+1
	end do
C
	return
	end

	subroutine zeroinfo(info,maxinfo,maxinfotypes)
	implicit none
	integer*4 maxinfo,maxinfotypes
	character*1 info(maxinfo,maxinfotypes)
	integer*4 i,j
	
	do j = 1,maxinfotypes
	  do i = 1, maxinfo
	    info(i,j)=char(0)
	  end do
	end do
	return
	end
	
	subroutine loadint2(trace,array,nrecords,maxtraceval)
	implicit none
	integer*4 nrecords
	integer*2 trace(nrecords),maxtraceval
	character*1 array(*)
C
	integer*4 i,j
	character*1 ca(2)
	integer*2   wa
	equivalence (wa,ca)
C
	j = 1
	do i = 1, nrecords
	  ca(1)=array(j)
	  j=j+1
	  ca(2)=array(j)
	  j=j+1
	  trace(i)=wa
	  if(trace(i) .gt. maxtraceval)maxtraceval=trace(i)
	end do
C
	return
	end


C
C	pad out a string to the length indicated with spaces
C
C
	subroutine spacesto(sarray,slen)
	implicit none
	integer*4 slen
	character*1 sarray(slen)
	integer*4 i
c
	i=1
	do while(sarray(i) .ne. char(0))
	  i = i + 1
	end do
	if(i .lt. slen)then
	  do while(i .lt. slen)
	    sarray(i)=' '
	    i = i + 1
	  end do
	  sarray(slen)=char(0) ! be sure that it terminates
	end if
	return
	end
